#include "xhbasic.h"
#include "ring.h"
#include "bring.h"
#include "Ring.xpm"
#include "Glitter.xpm"

Pixmap Ring_pxm = 0,Ring_mask = 0,Glitter_pxm = 0,Glitter_mask = 0;

Ring::Ring(XhedgehogWin *sw,float _x,float _y) :
  ZoneObject(sw,_x,_y,0,0,6,2) {
    if(!Ring_pxm) {
      sw->LoadPixmap(ring_xpm,&Ring_pxm,&Ring_mask);
      sw->LoadPixmap(glitter_xpm,&Glitter_pxm,&Glitter_mask);
    }
    ChangeSpriteShape(Ring_pxm,Ring_mask);
    pxm = Ring_pxm;
    maskpxm = Ring_mask;
    auto_animate = True; auto_hittest = True;
    g = 0; c = 0;
}

void Ring::MoveSprite(float newx,float newy) {
  MultiframeSprite::MoveSprite(newx,newy);
  if(g) {
    c++; if(c >= 5) Nuke();
  }
}

void BouncingRing::MoveSprite(float newx,float newy) {
  if(vy < 16) vy += 0.5;
  int ts;
  float tx = newx + (cx / 2); float ty = newy + cy;
  int f = ((XhedgehogWin *)host)->tspr->FetchTile((int)tx,(int)ty);
  if((ts = GetTileStatus(f)) != -1) {
    if(vy > 0)
      vy = (-vy) * 0.8;
  }
  tcount++; if(tcount > 200) Nuke();
  Ring::MoveSprite(newx,newy);
}


BouncingRing::BouncingRing(XhedgehogWin *sw,float _x,float _y,int f) :
  Ring(sw,_x,_y) {
    int d = f % 8;
    int e = f / 8;
    tcount = 0;
    switch(d) {
    case 0:
      vy = -4; vx = 0;
      break;
    case 1:
      vy = -2.828; vx = 2.828;
      break;
    case 2:
      vy = -2.828; vx = -2.828;
      break;
    case 3:
      vy = 0; vx = 4;
      break;
    case 4:
      vy = 0; vx = -4;
      break;
    case 5:
      vy = 2.828; vx = 2.828;
      break;
    case 6:
      vy = 2.828; vx = -2.828;
      break;
    case 7:
      vy = 4; vx = 0;
      break;
    }
    vy *= e + 1; vx *= e + 1;
}

void Ring::OnHitTest(Sprite *s) {
  if(!g) {
    if(dynamic_cast<Sonic *>(s) != NULL) {
      if(!(((Sonic *)s)->GetFlag(HITFLAG))) {
	SetGlitter();
	((Sonic *)s)->IncreaseRings();
      }
    }
  }
}


void Ring::SetGlitter() {
  g = 1;
  ChangeSpriteShape(Glitter_pxm,Glitter_mask);
  SetMaxFrames(4);
}
